#if (!defined(CFG_INCLUDED))
    #define CFG_INCLUDED 1


#define IND_NUMBER_DIGITS 4 // maximum number of digits
#define CFG_PARAMS 6 // number of configuration parameters
typedef struct {
    U8  ind_number[IND_NUMBER_DIGITS];
    U8  ind_mode;
    S16 params[CFG_PARAMS];
    U16 crc;
} struct_cfg;
struct_cfg cfg;

#define param_change_period      cfg.params[0] // parameter change period, sec
#define param_use_intt           cfg.params[1] // ==1 to use internal temperature
#define param_t_corr             cfg.params[2] // external temperature correction
#define param_time_corr          cfg.params[3] // ==1 to do winter/summer time correction
#define param_brightness_pwm_min cfg.params[4] // ==0..255 - minimum brightness control PWM value
#define param_brightness_pwm_max cfg.params[5] // ==0..255 - maximum brightness control PWM value


U8 cfg_upd_cnt; // configuration update counter
#define CFG_UPD_PERIOD 10 // configuration update delay after change, seconds
#define store_cfg() { cfg_upd_cnt = CFG_UPD_PERIOD; }

void setup_cfg(void);
void update_cfg(void);
S8   read_cfg(void);
void write_cfg(void);

#endif

