#include "ind.h"
#include "ul_kbd.h"


void setup_ind(void) {
    if ((cfg.ind_mode != IND_MO_NORMAL)&&(cfg.ind_mode != IND_MO_NUMBER))
        cfg.ind_mode = IND_MO_NORMAL;
    if (!rtc_present) cfg.ind_mode = IND_MO_NUMBER;
    ind_param = IND_PARAM_HOURMIN;
}

void update_ind(void) {

    // autoexit from setup
    if (ftmr_1() && ind_exit_tmr) {
        ind_exit_tmr--;
        if (ind_exit_tmr == 0) {
            if (cfg.ind_mode == IND_MO_SETUP) {
                cfg.ind_mode = IND_MO_NORMAL;
                ind_param = 0;
            } else if (cfg.ind_mode == IND_MO_NUMBER) {
                ind_number_digit = 0;
            } else if (cfg.ind_mode == IND_MO_SETUPEXT) {
                cfg.ind_mode = IND_MO_NORMAL;
                ind_param = 0;
            }
        }
    }

    // process blink timers
    ind_blink_cnt++;
    if (ind_blink_cnt >= IND_BLINK_PERIOD) ind_blink_cnt = 0;
    ind_rtc_blink_cnt++;
    if (ind_rtc_blink_cnt >= IND_RTC_BLINK_PERIOD) ind_rtc_blink_cnt = 0;



#if DEBUG_REMOTE == 1

    if (remote_codes_cnt < REMOTE_CODES) i7s_wr_S32( remote_codes_cnt, &i7s_buf[3], 0x00 | 3 );
    else {
        i7s_wr_S32( remote_codes[remote_code_cnt], &i7s_buf[3], 0x00 | 3 );
        if (ftmr_1()) {
            remote_code_cnt++;
            if (remote_code_cnt >= REMOTE_CODES) remote_code_cnt = 0;
        }
    }

#else

    if (cfg.ind_mode == IND_MO_NORMAL) {
        
        // parameters changing
        if (ftmr_1()) {
            ind_cycle_cnt++;
            if (ind_cycle_cnt >= param_change_period) {
                ind_cycle_cnt = 0;
                ind_param++;
                if (ind_param >= IND_CYCLE_PARAMS) ind_param = 0;

                if ((param_use_intt == 0)&&(ind_param == IND_PARAM_TEMPERATURE)&&(temperature_ext == TEMPERATURE_NAN))
                    ind_param = 0;
            }
        }
        
        if ((kbd_buf[1] == KBD_CO_SHOWMINSEC)&&(kbd_cnt >= KBD_CNT_LONG)) { // show minutes/seconds
            i7s_wr_S32( rtc.min, &i7s_buf[1], 0x88 | 1 );
            i7s_wr_S32( rtc.sec, &i7s_buf[3], 0x80 | 1 );
            if (ind_rtc_blink()) i7s_buf[2] &= I7S_SH;
        } else if ((kbd_buf[1] == KBD_CO_SHOWTEMP)&&(kbd_cnt >= KBD_CNT_LONG)) { // show temperature
            if (temperature_ext != TEMPERATURE_NAN) i7s_wr_S32( temperature_ext, &i7s_buf[3], 0x88 | 3 );
            else i7s_wr_S32( ds3231_temperature(), &i7s_buf[3], 0x88 | 3 );
        } else if (ind_param == IND_PARAM_HOURMIN) { // show hour/minute
            i7s_wr_S32( rtc.hr, &i7s_buf[1], 0x88 | 1 );
            i7s_wr_S32( rtc.min, &i7s_buf[3], 0x80 | 1 );
            if (ind_rtc_blink()) i7s_buf[2] &= I7S_SH;
        } else if (ind_param == IND_PARAM_DATEMONTH) { // show date/month
            i7s_wr_S32( rtc.date, &i7s_buf[1], 0x88 | 1 );
            i7s_wr_S32( rtc.month, &i7s_buf[3], 0x80 | 1 );
            i7s_buf[3] &= I7S_SH;
        } else if (ind_param == IND_PARAM_TEMPERATURE) { // show temperature
            S16 t = temperature_ext;
            if (t == TEMPERATURE_NAN) t = ds3231_temperature();
            S8 tt = (t >= 0) ? (t + 5) / 10 : (t - 5) / 10;
            if (tt < 0) tt = -tt;
            i7s_wr_S32( tt, &i7s_buf[1], 0x88 | 1 );
            i7s_buf[2] = I7S_SA & I7S_SB & I7S_SF & I7S_SG;
            i7s_buf[3] = I7S_C;
//            if (tt != 0) {
                if (t > 0) { // temperature positive - show '+'
                    i7s_buf[0] &= I7S_SH;
                    i7s_buf[1] &= I7S_SH;
                } else if (t < 0) { // temperature negative - show '-'
                    i7s_buf[0] &= I7S_SH;
                }
//            }
        }

//        i7s_wr_S32( remote_cnt_prev, &i7s_buf[3], 0x0 | 3 );
//        i7s_wr_S32( remote_dbg, &i7s_buf[3], 0x88 | 3 );
//        i7s_wr_S32( remote_code, &i7s_buf[3], 0x0 | 3 );
//      i7s_wr_S32( kbd_buf[1], &i7s_buf[3], 0x88 | 3 );
        //7s_wr_S32( lighting_pwm, &i7s_buf[3], 0x88 | 3 );
        //i7s_wr_S32( temperature_ext, &i7s_buf[3], 0x88 | 3 | (2 << 4) );
        //i7s_wr_S32( rtc_present, &i7s_buf[3], 0x88 | 3 );

    } else if (cfg.ind_mode == IND_MO_SETUP) { // clock setup

        if (ind_param == 0) {
            if (ind_blink()) i7s_buf[0] = i7s_buf[1] = I7S_ED_BLINK;
            else i7s_wr_S32( rtc.hr, &i7s_buf[1], 0x88 | 1 );
            i7s_wr_S32( rtc.min, &i7s_buf[3], 0x80 | 1 );
            if (ind_rtc_blink()) i7s_buf[2] &= I7S_SH;
        } else if (ind_param == 1) {
            i7s_wr_S32( rtc.hr, &i7s_buf[1], 0x88 | 1 );
            if (ind_blink()) i7s_buf[2] = i7s_buf[3] = I7S_ED_BLINK;
            else i7s_wr_S32( rtc.min, &i7s_buf[3], 0x80 | 1 );
            if (ind_blink()) i7s_buf[2] &= I7S_SH;
        } else if (ind_param == 2) {
            if (ind_blink()) i7s_buf[0] = i7s_buf[1] = I7S_ED_BLINK;
            else i7s_wr_S32( rtc.date, &i7s_buf[1], 0x88 | 1 );
            i7s_wr_S32( rtc.month, &i7s_buf[3], 0x80 | 1 );
            i7s_buf[3] &= I7S_SH;
        } else if (ind_param == 3) {
            i7s_wr_S32( rtc.date, &i7s_buf[1], 0x88 | 1 );
            if (ind_blink()) i7s_buf[2] = i7s_buf[3] = I7S_ED_BLINK;
            else i7s_wr_S32( rtc.month, &i7s_buf[3], 0x80 | 1 );
            i7s_buf[3] &= I7S_SH;
        } else if (ind_param == 4) {
            if (ind_blink()) i7s_buf[0] = i7s_buf[1] = i7s_buf[2] = i7s_buf[3] = I7S_ED_BLINK;
            else i7s_wr_S32( rtc.year, &i7s_buf[3], 0x88 | 3 );
        }
    }

    else if (cfg.ind_mode == IND_MO_NUMBER) { // edit number
        for (U8 digit_cnt=0; digit_cnt<IND_NUMBER_DIGITS; digit_cnt++) {
            U8 digit = cfg.ind_number[digit_cnt];
            if (digit == 10) digit = I7S_SPACE; else digit =  i7s_hexdig( digit );
            if (ind_blink() && (digit_cnt == (ind_number_digit - 1))) digit = I7S_ED_BLINK;
            i7s_buf[digit_cnt] = digit;
        }
        i7s_buf[3] &= I7S_SH;
    }

    else if (cfg.ind_mode == IND_MO_SETUPEXT) { // extended setup
        if (ind_blink()) i7s_buf[0] = I7S_SPACE; else i7s_wr_S32( ind_param_ext, &i7s_buf[0], 0x0 | 0 );
        i7s_wr_S32( cfg.params[ind_param_ext], &i7s_buf[3], 0x88 | 2 );
    }
#endif
    
    // update indication registers
    for (U8 cnt=0; cnt<I7S_BUF_SIZE; cnt++) {
        U8 digit = i7s_buf[cnt];
        for (U8 bit=0; bit<8; bit++) {
            I7S_C_P &= ~I7S_C_B;
            if (digit & 0x80) I7S_D_P &= ~I7S_D_B; else I7S_D_P |= I7S_D_B;
            I7S_C_P |= I7S_C_B;
            digit <<= 1;
        }
    }
    I7S_S_P &= ~I7S_S_B;
    I7S_S_P |= I7S_S_B;
    //I7S_E_P &= ~I7S_E_B;

}

void test_ind(void) {
}

