#if (!defined(IND_INCLUDED))
    #define IND_INCLUDED 1

// 7-segment indication
#define I7S_SA   ((U8)~0x10)
#define I7S_SB   ((U8)~0x08)
#define I7S_SC   ((U8)~0x04)
#define I7S_SD   ((U8)~0x02)
#define I7S_SE   ((U8)~0x01)
#define I7S_SF   ((U8)~0x20)
#define I7S_SG   ((U8)~0x40)
#define I7S_SH   ((U8)~0x80)

#define I7S_ED_BLINK I7S_SD

#define I7S_D_P  PORTD
#define I7S_D_B  (1 << PD0)
#define I7S_C_P  PORTD
#define I7S_C_B  (1 << PD3)
#define I7S_S_P  PORTD
#define I7S_S_B  (1 << PD1)
#define I7S_E_P  PORTB
#define I7S_E_B  (1 << PB3)


#define I7S_BUF_SIZE 4
#include "ul_i7s.h"

//U8 ind_mode;
U8 ind_param, ind_param_ext;
#define IND_PARAM_HOURMIN     0
#define IND_PARAM_DATEMONTH   1
#define IND_PARAM_TEMPERATURE 2
#define IND_PARAM_YEAR        3

#define IND_SETUP_PARAMS      5

#define IND_BLINK_PERIOD      5
U8 ind_blink_cnt;
#define ind_blink() (ind_blink_cnt <= (IND_BLINK_PERIOD / 2))

#define IND_RTC_BLINK_PERIOD  10
U8 ind_rtc_blink_cnt;
#define ind_rtc_blink() (ind_rtc_blink_cnt < (IND_RTC_BLINK_PERIOD / 2))


U8 ind_cycle_cnt;
#define IND_CYCLE_PARAMS      3

#define IND_MO_NORMAL         0
#define IND_MO_SETUP          1
#define IND_MO_SETUPEXT       2
#define IND_MO_SETUPEXTED     3
#define IND_MO_NUMBER         4

U8 ind_number_digit; // edited number digit

U8 ind_param; // displayed parameter
#define IND_PA_MAX_NORMAL 4 // number of parameters in SETUP mode


// setup exit timer
U8 ind_exit_tmr;
#define IND_EXIT_SETUP 30

void setup_ind(void);
void update_ind(void);

#endif

