#if (!defined(KBD_INCLUDED))
    #define KBD_INCLUDED 1


#define read_kbd() ( ((!(PINC & (1 << PC1))) << 0) | ((!(PINC & (1 << PC2))) << 1) | ((!(PINC & (1 << PC3))) << 2) )

#define KBD_KEYS          3 // number of keys


// keyboard codes
#define KBD_CO_NONE       0 // no key press
#define KBD_CO_UP         1 // up
#define KBD_CO_DOWN       2 // down
#define KBD_CO_SETUP      4 // setup
#define KBD_CO_NUMBER     KBD_CO_SETUP // switch to number mode
#define KBD_CO_RIGHT      KBD_CO_SETUP
#define KBD_CO_LEFT       8
#define KBD_CO_CORR       (KBD_CO_UP | KBD_CO_DOWN)
#define KBD_CO_SETUPEXT   (KBD_CO_UP | KBD_CO_SETUP)
#define KBD_CO_SHOWTEMP   (KBD_CO_UP)
#define KBD_CO_SHOWMINSEC (KBD_CO_DOWN)


// keyboard times
#define KBD_CNT_SHORT     10
#define KBD_CNT_LONG      200
#define KBD_CNT_SHOWACC   80
#define KBD_CNT_AUTO      80
#define KBD_CNT_RPT       (KBD_CNT_AUTO - 10)
#define KBD_CNT_SETUPEXT  200
#define KBD_CNT_EXIT      2000
#define KBD_CNT_IND_OFF   15000


#include "ul_kbd.h"


void setup_kbd(void);
void update_kbd(void);

#endif

