#include "rtc.h"

void setup_rtc(void) {
    rtc_present = !i2c_chkack( DS3231_ADDR );
    if (rtc_present) {
        ds3231_rd();
        if (!(ds3231_buf[DS3231_STAT] & 0x80)) { // first start
            ds3231_buf[DS3231_CNTR] = 0x80;
            ds3231_wr();
        }
        ds3231_to_rtc( &rtc );
    }
}

U8 rtc_update_cnt;
#define RTC_UPDATE_DIV 2
void update_rtc(void) {
    rtc_update_cnt++;
    if (rtc_update_cnt >= RTC_UPDATE_DIV) {
        rtc_update_cnt = 0;
        
        U8 prev_sec = rtc.sec;
        ds3231_rd();
        ds3231_to_rtc( &rtc );
        if (rtc.sec != prev_sec) { // seconds changed
            if (param_time_corr) { // do winter/summer correction
                if (rtc_correct_winter_summer( &rtc )) {
                    rtc_to_ds3231( &rtc );
                    ds3231_wr();
                }
            }
        }
    }
}

