#include "setup.h"

void setup(U8 mode) {
    
    cli();
    
    if (mode == SETUP_MO_NORMAL) { // setup in normal mode
        
        // ports
        PORTB = (1 << PB0)|(1 << PB1)|(1 << PB2)|(1 << PB3)|(1 << PB4)|(1 << PB5)|(1 << PB6)|(1 << PB7);
        DDRB  = (1 << PB3);
        PORTC = (1 << PC0)|(1 << PC1)|(1 << PC2)|(1 << PC3)|(1 << PC4)|(1 << PC5)|(1 << PC6);
        DDRC  = 0;
        PORTD = (1 << PD2)|(1 << PD4)|(1 << PD5)|(1 << PD6)|(1 << PD7);
        DDRD  = (1 << PD0)|(1 << PD1)|(1 << PD3)|(1 << PD4)|(1 << PD5)|(1 << PD6)|(1 << PD7);
        
        // timers
        TCCR0  = (1 << CS01); // prescaler=8
        TCCR2  = (1 << WGM20)|(1 << WGM21)|(1 << COM21)|(1 << COM20)|(1 << CS22)|(1 << CS21);
        OCR2   = 20;
        TIMSK  = (1 << TOIE0);
        
        // watchdog
        wdt_enable( WDTO_1S );
        
        // TWI
        TWBR = ((F_CPU / I2C_BAUD) - 16) / (2 * 1);
        //TWBR = 5;
        TWCR = (1 << TWEN);
        TWSR = 0;
        
        // setup modules
        setup_cfg(); // load configuration
        setup_i7s(); // setup low-level indication
        setup_rtc(); // setup RTC
        setup_ind(); // setup high-level indication
        setup_kbd(); // setup keyboard
        setup_temperature(); // setup temperature
    }
        
    sei();
}

