#include "temperature.h"

void setup_temperature(void) {
    temperature_ext = TEMPERATURE_NAN;
}

void update_temperature(void) {
    // read conversion result
    if (ds1w_res() != 0) temperature_ext = TEMPERATURE_NAN; // reset and sensor test
    else {
        ds1w_byte_wr(0xcc); // skip ROM
        ds1w_byte_wr(0xbe); // read scratchpad
        S16 temp = ds1w_12bit2tenth( ds1w_byte_rd() | ((U16)ds1w_byte_rd() << 8) );
        if ((temp != 850)&&(temperature_ext == TEMPERATURE_NAN)) temperature_ext = temp + param_t_corr;
        else if (temperature_ext != TEMPERATURE_NAN) temperature_ext = (temperature_ext + temp + param_t_corr) / 2;

        // start new conversion
        ds1w_res(); // reset
        ds1w_byte_wr(0xcc); // skip ROM
        ds1w_byte_wr(0x44); // start conversion
    }
}

