/** \addtogroup group_misc miscellaneous (разное) */

#if !defined(MISC_INCLUDED)
    #define MISC_INCLUDED

#include <stdint.h>

// short type names definitions
#define U8  uint8_t
#define u8  U8
#define S8  int8_t
#define s8  S8
#define U16 uint16_t
#define u16 U16
#define S16 int16_t
#define s16 S16
#define U32 uint32_t
#define u32 U32
#define S32 int32_t
#define s32 S32
#define U64 uint64_t
#define u64 U64
#define S64 int64_t
#define s64 S64


// inlines
#define wdr_avr()   asm volatile("wdr")
#define nop_avr()   asm volatile("nop")
#define sleep_avr() asm volatile("sleep")
#define cli_avr()   asm volatile("cli")
#define sei_avr()   asm volatile("sei")
#define cli_8051()  EI = 0
#define sei_8051()  EI = 1
#define cli_stm8()  _asm("sim")
#define sei_stm8()  _asm("rim")
#define nop_stm8()  _asm("nop")
#define wdr_stm8()  { IWDG_KR = 0xAA; }


// setup modes
#define SETUP_MO_NORMAL 0x00
#define SETUP_MO_SLEEP  0xFF


#ifndef NAKED
    #define NAKED __attribute__ ((naked))
#endif
#ifndef NORETURN
    #define NORETURN __attribute__ ((noreturn))
#endif
#ifndef CONST
    #define CONST __attribute__ ((const))
#endif
#ifndef PROGMEM
    #define PROGMEM __attribute__((__progmem__))
#endif
#ifndef EEMEM
    #define EEMEM __attribute__ ((section (".eeprom")))
#endif
#ifndef NOINIT
    #define NOINIT __attribute__ ((section (".noinit"))) 
#endif
#ifndef INTERRUPT
    #define INTERRUPT __attribute__((interrupt))
#endif
#ifndef ISR
    #define ISR __attribute__ ((signal))
#endif
#ifndef USED
    #define USED __attribute__ ((used))
#endif

#endif

