#include "ul_remote.h"


void setup_remote(void) {
    remote_code = remote_code_prev = REMOTE_CO_NONE;
}

__attribute__((noinline)) void update_remote(void) {
    remote_state_prev = remote_state;
    remote_state = read_remote();
    if (remote_state == remote_state_prev) { // state not changed - increment counter
        if (remote_cnt < REMOTE_CNT_MAX) remote_cnt++;
        if (remote_state && (remote_cnt >= REMOTE_SONY_OFF_GAP)) {
            remote_bits_cnt = 0;
            remote_data = 0;
        }
    } else { // state changed
        remote_cnt_preprev = remote_cnt_prev;
        remote_cnt_prev = remote_cnt;
        remote_cnt = 0;
        
        if (remote_state) { // transition 0->1 - start bit or data bit

#if REMOTE_TYPE == REMOTE_TYPE_SONY // receive SONY protocol
            if ((remote_cnt_preprev >= REMOTE_SONY_START_PRE_MAX) &&
                (remote_cnt_prev >= REMOTE_SONY_START_MIN) &&
                (remote_cnt_prev <= REMOTE_SONY_START_MAX)) { // start pulse
                remote_data = remote_bits_cnt = 0; // clear data buffer
            } else if ((remote_cnt_preprev >= REMOTE_SONY_SPACE_MIN)&&(remote_cnt_preprev <= REMOTE_SONY_SPACE_MAX)) {
                if ((remote_cnt_prev >= REMOTE_SONY_0_MIN)&&(remote_cnt_prev <= REMOTE_SONY_0_MAX)) { // received bit 0
                    if (remote_bits_cnt < REMOTE_BITS_MAX) {
                        remote_bits_cnt++;
                        remote_data <<= 1;
                    }
                } else if ((remote_cnt_prev >= REMOTE_SONY_1_MIN)&&(remote_cnt_prev <= REMOTE_SONY_1_MAX)) { // received bit 1
                    if (remote_bits_cnt < REMOTE_BITS_MAX) {
                        remote_bits_cnt++;
                        remote_data <<= 1;
                        remote_data |= 1;
                    }
                }
            }
            // store final code
            if ((remote_bits_cnt == REMOTE_BITS_MAX)&&(remote_code == REMOTE_CO_NONE))
                remote_code = remote_data;
#endif

        }
    }
}

