#if (!defined(REMOTE_INCLUDED))
    #define REMOTE_INCLUDED 1


#if (!defined(REMOTE_BITS_MAX))
    #define REMOTE_BITS_MAX    12 // maximum number of bits in pulse
#endif

#if REMOTE_BITS_MAX <= 8
    #define REMOTE_BUF_TYPE U8
#elif REMOTE_BITS_MAX <= 16
    #define REMOTE_BUF_TYPE U16
#else
    #define REMOTE_BUF_TYPE U32
#endif

U8  remote_cnt, remote_cnt_prev, remote_cnt_preprev; // remote line state counters
U8  remote_nopress_cnt;
U8  remote_state, remote_state_prev; // remote line current and previous state
REMOTE_BUF_TYPE remote_data, remote_code, remote_code_prev; // collected received bits, current and previous code
U8  remote_bits_cnt; // received bits count
U16 remote_debug;
U8  remote_process_delay_cnt;

#define REMOTE_CODES 10
REMOTE_BUF_TYPE remote_codes[REMOTE_CODES];
U8 remote_codes_cnt, remote_code_cnt;

#define REMOTE_PROCESS_DELAY_LONG  150
#define REMOTE_PROCESS_DELAY_SHORT 50


#if (!defined(REMOTE_CNT_MAX))
    #define REMOTE_CNT_MAX     255 // min/max counter values for start/data bits
#endif
#if (!defined(REMOTE_TOL_MINUS))
    #define REMOTE_TOL_MINUS   1 // captured time minimum tolerance
#endif
#if (!defined(REMOTE_TOL_PLUS))
    #define REMOTE_TOL_PLUS    1 // captured time maximum tolerance
#endif


#define REMOTE_TYPE_SONY 0

// Sony protocol timing
#define REMOTE_SONY_OFF_GAP       (2500UL * F_REMOTE / 1000000UL)
#define REMOTE_SONY_START_PRE_MAX (700UL * F_REMOTE / 1000000UL)
#define REMOTE_SONY_START_MIN     ((2500UL * F_REMOTE / 1000000UL) - REMOTE_TOL_MINUS)
#define REMOTE_SONY_START_MAX     ((2500UL * F_REMOTE / 1000000UL) + REMOTE_TOL_PLUS)
#define REMOTE_SONY_SPACE_MIN     ((600UL * F_REMOTE / 1000000UL) - REMOTE_TOL_MINUS)
#define REMOTE_SONY_SPACE_MAX     ((600UL * F_REMOTE / 1000000UL) + REMOTE_TOL_PLUS)
#define REMOTE_SONY_0_MIN         ((600UL * F_REMOTE / 1000000UL) - REMOTE_TOL_MINUS)
#define REMOTE_SONY_0_MAX         ((600UL * F_REMOTE / 1000000UL) + REMOTE_TOL_PLUS)
#define REMOTE_SONY_1_MIN         ((1200UL * F_REMOTE / 1000000UL) - REMOTE_TOL_MINUS)
#define REMOTE_SONY_1_MAX         ((1200UL * F_REMOTE / 1000000UL) + REMOTE_TOL_PLUS)


#define REMOTE_CO_NONE              0xFFFF
#define REMOTE_CO_SONYRM887_ONOFF   0xA90
#define REMOTE_CO_SONYRM887_VOLUP   0x490
#define REMOTE_CO_SONYRM887_VOLDOWN 0xC90
#define REMOTE_CO_SONYRM887_CHNUP   0x090
#define REMOTE_CO_SONYRM887_CHNDOWN 0x890
#define REMOTE_CO_SONYRM887_UP      0x2F0
#define REMOTE_CO_SONYRM887_DOWN    0xAF0
#define REMOTE_CO_SONYRM887_LEFT    0x2D0
#define REMOTE_CO_SONYRM887_RIGHT   0xCD0
#define REMOTE_CO_SONYRM887_0       0x910
#define REMOTE_CO_SONYRM887_1       0x010
#define REMOTE_CO_SONYRM887_2       0x810
#define REMOTE_CO_SONYRM887_3       0x410
#define REMOTE_CO_SONYRM887_4       0xC10
#define REMOTE_CO_SONYRM887_5       0x210
#define REMOTE_CO_SONYRM887_6       0xA10
#define REMOTE_CO_SONYRM887_7       0x610
#define REMOTE_CO_SONYRM887_8       0xE10
#define REMOTE_CO_SONYRM887_9       0x110
#define REMOTE_CO_SONYRM887_OK      0xA70
#define REMOTE_CO_SONYRM887_MUTE    0x290
#define REMOTE_CO_SONYRM887_MENU    0x070
#define REMOTE_CO_SONYRM887_RETURN  0xDD0
#define REMOTE_CO_SONYRM887_TV      0x1D0
#define REMOTE_CO_SONYRM887_OSD     0xFD0


void setup_remote(void);
void update_remote(void);

#endif

