#include "ul_rtc_ds3231.h"
#include "ul_math.h"

void ds3231_to_rtc(struct_rtc *rtc) {
    // store time/date to RTC structure
    (*rtc).sec   = bcd2bin_U8(ds3231_buf[DS3231_SECOND]);
    (*rtc).min   = bcd2bin_U8(ds3231_buf[DS3231_MINUTE]);
    (*rtc).hr    = bcd2bin_U8(ds3231_buf[DS3231_HOUR]);
    (*rtc).date  = bcd2bin_U8(ds3231_buf[DS3231_DATE]);
    (*rtc).month = bcd2bin_U8(ds3231_buf[DS3231_MONTH]);
    (*rtc).year  = 2000 + bcd2bin_U8(ds3231_buf[DS3231_YEAR]);
}
void rtc_to_ds3231(struct_rtc *rtc) {
    ds3231_buf[DS3231_SECOND] = bin2bcd_U8((*rtc).sec);
    ds3231_buf[DS3231_MINUTE] = bin2bcd_U8((*rtc).min);
    ds3231_buf[DS3231_HOUR]   = bin2bcd_U8((*rtc).hr);
    ds3231_buf[DS3231_DATE]   = bin2bcd_U8((*rtc).date);
    ds3231_buf[DS3231_MONTH]  = bin2bcd_U8((*rtc).month);
    ds3231_buf[DS3231_YEAR]   = bin2bcd_U8((*rtc).year - 2000);
}

void ds3231_rd(void) {
    i2c_rd_a8_buf8( DS3231_ADDR, 0, &ds3231_buf[0], DS3231_REGS_SIZE );
}
void ds3231_wr(void) {
    i2c_wr_a8_buf8( DS3231_ADDR, 0, &ds3231_buf[0], DS3231_REGS_SIZE );
}

S16 ds3231_temperature(void) {
    U16 t = (((U16)(ds3231_buf[DS3231_TEMP_MSB] & ~0x80)) << 2) | (((U16)ds3231_buf[DS3231_TEMP_LSB]) >> 6);
    t = (t * 5) >> 1;
    if (ds3231_buf[DS3231_TEMP_MSB] & 0x80) t = -t;
    return (S16)t;
}

