#include "sclk_4dig_01.h"


int main(void) {                  // main function

    delay_us(100);                // startup delay
    setup( SETUP_MO_NORMAL );     // setup hardware
    
    while (1) {                   // main loop
    
        wdr();                    // reset WDT
        tmr_flags_sync();         // synchronize timing flags
        
        if (ftmr_001()) {         // 100Hz events
            update_kbd();         // update keyboard
        }
        
        if (ftmr_01()) {          // 10Hz events
            update_ind();         // update indication
            if (rtc_present) update_rtc(); // update RTC
        }
        
        if (ftmr_1()) {           // 1Hz events
            update_temperature(); // measure temperature
            update_lighting();    // measure lighting
            update_cfg();         // update config
        }
    }
}


ISR(TIMER0_OVF_vect) {            // Timer 0 overflow ISR
    TCNT0 = TCNT0_VAL;            // reload Timer 0 counter
    tmr_flags_upd();              // update timing flags
    update_remote();              // update remote
}

